require 'rainbow'

module Kojak
  # Internal: Abstract design of a printing class.
  #
  # This is just a stub with documentation, implement actual printers
  # in inherited classes.
  class Printer
    # Public: Writes given string and a newline.
    #
    # s    - The String to print.
    # args - The Array with interpolation arguments.
    #
    # Should return number of writen characters.
    def puts(s, *args)
      write("#{s}\n", *args)
    end

    # Public: Writes given string to the output.
    #
    # s    - The String to print.
    # args - The Array with interpolation arguments.
    #
    # Should return number of written characters.
    def write(s, *args)
    end
  end

  require 'kojak/printer/nulled'
  require 'kojak/printer/basic'
  require 'kojak/printer/synchronized'
  require 'kojak/printer/colorized'
  require 'kojak/printer/randomly_colorized'
end
