require 'json'

module Kojak
  # Internal: Basic printer. It prints stuff to configured output stream.
  class Printer::Basic < Printer
    # Public: Constructor. Configures printer to write to given output stream.
    #
    # out - The Stream to write data to.
    #
    # Returns nothing.
    def initialize(out)
      @out = out
    end

    def write(s, *args)
      args = args.map { |x| JSON.pretty_generate(x) rescue x.inspect }
      @out.write(s.to_s % args)
    end
  end
end
